#include <stdlib.h>
#include <stdio.h>
#include "mex.h"
#include "math.h"

/************************************************************************/
/*                                                                      */
/* MAIN FUNCTION                                                        */
/*                                                                      */
/************************************************************************/

void mexFunction(int nlhs,mxArray *plhs[],int nrhs,const mxArray *prhs[]) {
    
    /* declarations */
    double *a,*b, *x,*out1;
    int m,m2,Ny,i,j,maxit;
    double c,d,h,qab,qam,qap,stp,*coef,tmp,eps,fpmin,aa,del;
    
    
    /*     check input*/
    if (nrhs!=3)     mexErrMsgTxt("Three input!");
    if (mxIsEmpty(prhs[0]))mexErrMsgTxt("The first input is empty!");
    if (mxIsEmpty(prhs[1]))mexErrMsgTxt("The second input is empty!");
    if (mxIsEmpty(prhs[2]))mexErrMsgTxt("The third input is empty!");
    /* get input data */
    a=mxGetPr(prhs[0]);
    b=mxGetPr(prhs[1]);
    x=mxGetPr(prhs[2]);
    
    maxit=100;
    eps=2.220446049250313e-016;
    fpmin=2.225073858507201e-308/eps;
    qab=a[0]+b[0];
    
    qap=a[0]+1.0;
    qam=a[0]-1.0;
    c=1.0;
    d=1.0-qab*x[0]/qap;
    if (abs(d) < fpmin)d=fpmin;
    
    d=1.0/d;
    
    h=d;
    
    
    plhs[0]=mxCreateDoubleMatrix(1,1,mxREAL);
    out1=mxGetPr(plhs[0]);
    
    for(m=0;m<maxit;m++)
    {
        m2=2*m;
        
        aa=m*(b[0]-m)*x[0]/((qam+m2)*(a[0]+m2));
        
        d=1.0+aa*d;
        if (abs(d) < fpmin)d=fpmin;
        
        c=1.0+aa/c;
        
        if (abs(c) < fpmin)c=fpmin;
        
        d=1.0/d;
        
        h=h*d*c;
        
        aa=-(a[0]+m)*(qab+m)*x[0]/((a[0]+m2)*(qap+m2));
        
        d=1.0+aa*d;
        if (abs(d) < fpmin)d=fpmin;
        
        c=1.0+aa/c;
        
        if (abs(c) < fpmin)c=fpmin;
        d=1.0/d;
        
        del=d*c;
        h=h*del;
        
        if (abs(del-1.0) <= eps)
        {
            out1[0]=h;
            return;
        }
        
        
        out1[0]=h;
        
        
        
    }
    
}
    
    
    
    
