/*
 * Yongxiang Huang, last modification: 09/04/2014
 * yongxianghuang@gmail.com
 *
 */

/* This function is to perform a beta model
 */

#include <stdlib.h>
#include <stdio.h>
#include "mex.h"
#include <math.h>






/************************************************************************/
/*                                                                      */
/* MAIN FUNCTION                                                        */
/*                                                                      */
/************************************************************************/

void mexFunction(int nlhs,mxArray *plhs[],int nrhs,const mxArray *prhs[]) {
    
    /* declarations */
    mwSize  pSizeI, pSizeB;
    
    int i,j,k,kk,i0,j0,k0,Np;
    
    double *r,*df,*tiny,*prob,*z,*a,*b,*x,*t,*bt,*gab,*ga,*gb,*stp,*coef;
    /*instantaneous frequency, instantaneous amplitude, resolution of amplitude resolution frequency*/
    
    
    /*     check input*/
    if (nrhs!=3)     mexErrMsgTxt("You have to input three parameters!");
    if (mxIsEmpty(prhs[0]))mexErrMsgTxt("r is empty!");
    if (mxIsEmpty(prhs[1]))mexErrMsgTxt("df is empty!");
    if (mxIsEmpty(prhs[2]))mexErrMsgTxt("tiny is empty!");
    
    /* get input data */
    r=mxGetPr(prhs[0]);
    df=mxGetPr(prhs[1]);
    tiny=mxGetPr(prhs[2]);
    
    
    stp[0] = 2.5066282746310005;
    
    coef=(double *)malloc(6*sizeof(double));;

    coef[0] = 76.18009172947146;
    coef[1] =-86.50532032941677;
    coef[2] =24.01409824083091;
    coef[3] =-1.231739572450155;
    coef[4] =0.1208650973866179e-2;
    coef[5] =-0.5395239384953e-5;
    
    plhs[0]=mxCreateDoubleMatrix(1,1,mxREAL);
    prob=mxGetPr(plhs[0]);
    
    plhs[1]=mxCreateDoubleMatrix(1,1,mxREAL);
    z=mxGetPr(plhs[1]);
    
    z[0]=0.5e0*log(((1.0e0+r[0])+tiny[0])/((1.0e0-r[0])+tiny[0])); 

    t[0]=r[0]*pow(df[0]/(((1.0e0-r[0])+tiny[0])*((1.0e0+r[0])+tiny[0])),0.5); 

    a[0]=0.5e0*df[0];
    b[0]=0.5e0;
    
    x[0]=df[0]/(df[0]+pow(t[0],22.0));
    
    if (x[0]==0.0||x[0]==1.0){bt[0]=0;}
    else
    {
        
        
    bt[0]=exp(gab[0]-ga[0]-gb[0] +a[0]*log(x[0])+b[0]*log(1.0e0-x[0]));
    }
    
    free(coef);
}

