#include <stdlib.h>
#include <stdio.h>
#include "mex.h"
#include "math.h"

/************************************************************************/
/*                                                                      */
/* MAIN FUNCTION                                                        */
/*                                                                      */
/************************************************************************/

void mexFunction(int nlhs,mxArray *plhs[],int nrhs,const mxArray *prhs[]) {
    
    /* declarations */
    double *x,*a,*b,*out1;
    int dof,Nx,Ny,i,j;
    double stp,*coef,tmp,xx,tmp2;
    
    
    /*     check input*/
    if (nrhs!=3)     mexErrMsgTxt("Three input!");
    if (mxIsEmpty(prhs[0]))mexErrMsgTxt("The first input is empty!");
    if (mxIsEmpty(prhs[1]))mexErrMsgTxt("The second input is empty!");
    if (mxIsEmpty(prhs[2]))mexErrMsgTxt("The thrid input is empty!");
    
    /* get input data */
    a=mxGetPr(prhs[0]);
    b=mxGetPr(prhs[1]);
    x=mxGetPr(prhs[2]);
    
    
    stp = 2.5066282746310005;
    
    
    coef=(double *)malloc(6*sizeof(double));;
    coef[0] = 76.18009172947146;
    coef[1] = -86.50532032941677;
    coef[2] = 24.01409824083091;
    coef[3] = -1.231739572450155;
    coef[4] = 0.1208650973866179e-2;
    coef[5] = -0.5395239384953e-5;
    
    
    plhs[0]=mxCreateDoubleMatrix(1,1,mxREAL);
    out1=mxGetPr(plhs[0]);
    
    xx=a[0]+b[0];
    tmp=xx+5.5;
    tmp=(xx+0.5)*log(tmp)-tmp;
    
    tmp2=tmp+log(stp*(1.000000000190015+(coef[0]+coef[1]+coef[2]+coef[3]+coef[4]+coef[5])/(xx+1.0))/xx);
    
    xx=a[0];
    tmp=xx+5.5;
    tmp=(xx+0.5)*log(tmp)-tmp;
    
    tmp=tmp+log(stp*(1.000000000190015+(coef[0]+coef[1]+coef[2]+coef[3]+coef[4]+coef[5])/(xx+1.0))/xx);
    tmp2=tmp2-tmp;
    
    xx=b[0];
    tmp=xx+5.5;
    tmp=(xx+0.5)*log(tmp)-tmp;
    
    tmp=tmp+log(stp*(1.000000000190015+(coef[0]+coef[1]+coef[2]+coef[3]+coef[4]+coef[5])/(xx+1.0))/xx);
    tmp2=tmp2-tmp;
    
   tmp2=tmp2+ a[0]*log(x[0])+b[0]*log(1.0-x[0]);
   out1[0]=exp(tmp2);
    /* free allocated memory */
    
    free(coef);
    
    
}






