#include <stdlib.h>
#include <stdio.h>
#include "mex.h"
#include "math.h"

/************************************************************************/
/*                                                                      */
/* MAIN FUNCTION                                                        */
/*                                                                      */
/************************************************************************/

void mexFunction(int nlhs,mxArray *plhs[],int nrhs,const mxArray *prhs[]) {
    
    /* declarations */
    double *xx,*out1;
    int dof,Nx,Ny,i,j;
    double stp,*coef,tmp,arthr;
    
    
    /*     check input*/
    if (nrhs!=1)     mexErrMsgTxt("Only input!");
    if (mxIsEmpty(prhs[0]))mexErrMsgTxt("The first time series is empty!");
    
    /* get input data */
    xx=mxGetPr(prhs[0]);
    
    
    stp = 2.5066282746310005;
    
    
    coef=(double *)malloc(6*sizeof(double));;
    coef[0] = 76.18009172947146;
    coef[1] = -86.50532032941677;
    coef[2] = 24.01409824083091;
    coef[3] = -1.231739572450155;
    coef[4] = 0.1208650973866179e-2;
    coef[5] = -0.5395239384953e-5;
    
    
    plhs[0]=mxCreateDoubleMatrix(1,1,mxREAL);
    out1=mxGetPr(plhs[0]);
    
    
    tmp=xx[0]+5.5;
    tmp=(xx[0]+0.5)*log(tmp)-tmp;
    
    
    
    
    
    
    out1[0]=tmp+log(stp*(1.000000000190015+(coef[0]+coef[1]+coef[2]+coef[3]+coef[4]+coef[5])/(xx[0]+1.0))/xx[0]);
    
    
    
    
    /* free allocated memory */
    
    free(coef);
    
    
}






