#include <stdlib.h>
#include <stdio.h>
#include "mex.h"
#include "math.h"

/************************************************************************/
/*                                                                      */
/* MAIN FUNCTION                                                        */
/*                                                                      */
/************************************************************************/

void mexFunction(int nlhs,mxArray *plhs[],int nrhs,const mxArray *prhs[]) {
    
    /* declarations */
    mwSize  pSizeX, pSizeY;

    double *x,*y,*out1,*df;
    int i,j;
    double tmp,stdx,stdy,tiny;
    
    
    /*     check input*/
    if (nrhs!=3)     mexErrMsgTxt("Three input!");
    if (mxIsEmpty(prhs[0]))mexErrMsgTxt("The first is empty!");
    if (mxIsEmpty(prhs[1]))mexErrMsgTxt("The second is empty!");
    if (mxIsEmpty(prhs[2]))mexErrMsgTxt("The second is empty!");
    /* get input data */
    x=mxGetPr(prhs[0]);
    y=mxGetPr(prhs[1]);
    df=mxGetPr(prhs[2]);

        
    tiny=1.0e-20;
    
    
    pSizeX = mxGetNumberOfElements(prhs[0]);
    pSizeY = mxGetNumberOfElements(prhs[1]);
    if(pSizeX!=pSizeY)mexErrMsgTxt("Two inputs should have the same length!");
    
    plhs[0]=mxCreateDoubleMatrix(1,3,mxREAL);
    out1=mxGetPr(plhs[0]);
    
    tmp=0.0;
    for(i=0;i<pSizeX;i++)tmp=tmp+x[i];
    tmp=tmp/pSizeX;
    for(i=0;i<pSizeX;i++)x[i]=-tmp+x[i];
    
    
    tmp=0.0;
    for(i=0;i<pSizeX;i++)tmp=tmp+y[i];
    tmp=tmp/pSizeX;
    for(i=0;i<pSizeX;i++)y[i]=-tmp+y[i];
    
    tmp=0.0;
    for(i=0;i<pSizeX;i++)tmp=tmp+x[i]*x[i];
    tmp=tmp/pSizeX;
    stdx=sqrt(tmp)+tiny;
    
    tmp=0.0;
    for(i=0;i<pSizeX;i++)tmp=tmp+y[i]*y[i];
    tmp=tmp/pSizeX;
    stdy=sqrt(tmp)+tiny;
    
    
    tmp=0.0;
    for(i=0;i<pSizeX;i++)tmp=tmp+x[i]*y[i];
    tmp=tmp/pSizeX;
    out1[0]=tmp/stdx/stdy;
    
    
    out1[1]=0.5e0*log(((1.0e0+out1[0])+tiny)/((1.0e0-out1[0])+tiny));
            
    out1[2]=out1[0]*sqrt(df[0]/(((1.0e0-out1[0])+tiny)*((1.0e0+out1[0])+tiny))); 
    
}






