/*
 *perfrom a student test
 * Yongxiang Huang, last modification: 05/05/2014
 * yongxianghuang@gmail.com
 *
 */

/* This function is to perform a beta model
 */

#include <stdlib.h>
#include <stdio.h>
#include "mex.h"
#include <math.h>






/************************************************************************/
/*                                                                      */
/* MAIN FUNCTION                                                        */
/*                                                                      */
/************************************************************************/

void mexFunction(int nlhs,mxArray *plhs[],int nrhs,const mxArray *prhs[]) {
    
    /* declarations */
    mwSize  pSizeI, pSizeB;
    
    int i,j,k,kk,i0,j0,k0,Np;
    
    double *t,*df,*a,*b,*c,*d,*e1,*f,*g,*h,*i1,*j1,*out1;
    double nonsense,v,pos,x;
    /*instantaneous frequency, instantaneous amplitude, resolution of amplitude resolution frequency*/
    
    
    /*     check input*/
    if (nrhs!=2)     mexErrMsgTxt("You have to input three parameters!");
    if (mxIsEmpty(prhs[0]))mexErrMsgTxt("t is empty!");
    if (mxIsEmpty(prhs[1]))mexErrMsgTxt("df is empty!");
    
    
    /* get input data */
    t=mxGetPr(prhs[0]);
    df=mxGetPr(prhs[1]);
    
    
    nonsense=99999.99;
    
    a=(double *)malloc(5*sizeof(double));;
    a[0] = 0.09979441;
    a[1] = -0.581821;
    a[2] = 1.390993;
    a[3] = -1.222452;
    a[4] = 2.151185;
    
    b=(double *)malloc(2*sizeof(double));;
    b[0] = 5.537409;
    b[1] = 11.42343;
    
    c=(double *)malloc(5*sizeof(double));;
    c[0] = 0.04431742;
    c[1] = -0.2206018;
    c[2] = -0.03317253;
    c[3] = 5.679969;
    c[4] = -12.96519;
    
    d=(double *)malloc(2*sizeof(double));;
    d[0] = 5.166733;
    d[1] = 13.49862;
    
    e1=(double *)malloc(5*sizeof(double));;
    e1[0] = 0.009694901;
    e1[1] = -0.1408854;
    e1[2] = 1.88993;
    e1[3] = -12.75532;
    e1[4] = 25.77532;
    
    
    f=(double *)malloc(2*sizeof(double));;
    f[0] = 4.233736;
    f[1] = 14.3963;
    
    g=(double *)malloc(5*sizeof(double));;
    g[0] = -9.187228e-5;
    g[1] = 0.03789901;
    g[2] = -1.280346;
    g[3] = 9.249528;
    g[4] = -19.08115;
    
    
    h=(double *)malloc(2*sizeof(double));;
    h[0] = 2.777816;
    h[1] = 16.46132;
    
    
    i1=(double *)malloc(5*sizeof(double));;
    i1[0] = 5.79602e-4;
    i1[1] = -0.02763334;
    i1[2] = 0.4517029;
    i1[3] = -2.657697;
    i1[4] = 5.127212;
    
    
    j1=(double *)malloc(2*sizeof(double));;
    
    j1[0] = 0.5657187;
    j1[1] = 21.83269;
    
    
    
    plhs[0]=mxCreateDoubleMatrix(1,1,mxREAL);
    out1=mxGetPr(plhs[0]);
    
    
    
    if (df[0] <= 4.0)
    {
        out1[0] = nonsense;
        return;
    }
    
    
    v = 1.0 / df[0];
    if(t>=0)pos=1.0;
    else pos=0;
    
    
    if(t[0]<0)t[0] = -t[0];
    x = (1.0 +t[0]*(((a[0] + v*(a[1] + v*(a[2] + v*(a[3] + v*a[4])))) / (1.0 - v*(b[0] - v*b[1]))) + t[0]*(((c[0] + v*(c[1] + v*(c[2] + v*(c[3] + v*c[4])))) / (1.0 - v*(d[0] - v*d[1]))) + t[0]*(((e1[0] + v*(e1[1] + v*(e1[2] + v*(e1[3] + v*e1[4])))) / (1.0 - v*(f[0] - v*f[1]))) +t[0]*(((g[0] + v*(g[1] + v*(g[2] + v*(g[3] + v*g[4])))) / (1.0 - v*(h[0] - v*h[1]))) + t[0]*((i1[0] + v*(i1[1] + v*(i1[2] + v*(i1[3] + v*i1[4])))) / (1.0 - v*(j1[0] - v*j1[1]))) )))));
    x=0.5*pow(x,-8);
    if (pos==1.0)
        out1[0] = x;
    else
        out1[0] = 1.0 - x;
    
            
          
            
            free(a);
    free(b);
    free(c);
    free(d);
    free(e1);
    free(g);
    free(h);
    free(i1);
    free(j1);
    
}

